lev.gui

## Class LList<T>

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - lev.gui.LComponent
      - - lev.gui.LHelpComponent
        - - lev.gui.LList<T>

- Type Parameters:
    `T` -
  All Implemented Interfaces:
    java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.lang.Iterable<T>

      public class LList<T>
      extends LHelpComponent
      implements java.lang.Iterable<T>

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class lev.gui.LHelpComponent

      `LHelpComponent.HelpActionHandler, LHelpComponent.HelpFocusHandler, LHelpComponent.HelpMouseHandler`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.util.Comparator` | `compare`
    `protected javax.swing.JList<T>` | `list`
    `protected javax.swing.DefaultListModel<T>` | `model`
    `protected javax.swing.JScrollPane` | `scroll`
    `protected static int` | `spacing`
    `protected boolean` | `unique`

    - ### Fields inherited from class lev.gui.LHelpComponent

      `followPos, help, helpPrefix, helpYoffset, save, saveTie, title`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LList(java.lang.String title)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addElement(T o)`
    `void` | `addElements(java.util.Collection<T> in)`
    `protected void` | `addHelpHandler(boolean hoverListener)` Adds a help handler to each GUI component that should trigger the help panel to update.
    `void` | `addListSelectionListener(javax.swing.event.ListSelectionListener l)`
    `void` | `addMouseListener(java.awt.event.MouseListener m)`
    `void` | `clear()`
    `void` | `clearHighlight()`
    `java.util.ArrayList<T>` | `getAll()`
    `T` | `getSelectedElement()`
    `java.util.List<T>` | `getSelectedElements()`
    `void` | `highlightChanged()`
    `boolean` | `isEmpty()`
    `java.util.Iterator<T>` | `iterator()`
    `int` | `numItems()`
    `void` | `removeSelected()`
    `void` | `setSelectedElement(int index)`
    `void` | `setSize(int width, int height)`
    `void` | `setUnique(boolean on)`

    - ### Methods inherited from class lev.gui.LHelpComponent

      `addHelpPrefix, getHelp, hasHelp, isFollowingPosition, linkTo, setFollowPosition, updateHelp`

    - ### Methods inherited from class lev.gui.LComponent

      `Add, centerIn, centerOn, centerOn, getBottom, getCenter, getRight, putUnder`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addNotify, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getInsets, getLayout, getListeners, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, isValidateRoot, layout, list, list, locate, minimumSize, paint, paintComponents, paramString, preferredSize, print, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, removeNotify, setComponentZOrder, setFocusCycleRoot, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, setLayout, transferFocusDownCycle, update, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getAccessibleContext, getBackground, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getToolkit, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, reshape, resize, resize, revalidate, setBackground, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setLocation, setLocation, setMaximumSize, setMinimumSize, setName, setPreferredSize, setSize, setVisible, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### model

          protected javax.swing.DefaultListModel<T> model

    - #### list

          protected javax.swing.JList<T> list

    - #### scroll

          protected javax.swing.JScrollPane scroll

    - #### unique

          protected boolean unique

    - #### compare

          protected java.util.Comparator compare

    - #### spacing

          protected static int spacing

  - ### Constructor Detail

    - #### LList

          public LList(java.lang.String title)

      Parameters:
        `title` -

  - ### Method Detail

    - #### setSize

          public void setSize(int width,
                     int height)

      Overrides:
        `setSize` in class `java.awt.Component`

    - #### addElement

          public void addElement(T o)

      Parameters:
        `o` -

    - #### addElements

          public void addElements(java.util.Collection<T> in)

      Parameters:
        `in` -

    - #### getSelectedElements

          public java.util.List<T> getSelectedElements()

      Returns:

    - #### getSelectedElement

          public T getSelectedElement()

      Returns:

    - #### setSelectedElement

          public void setSelectedElement(int index)

      Parameters:
        `index` -

    - #### removeSelected

          public void removeSelected()

    - #### numItems

          public int numItems()

      Returns:

    - #### isEmpty

          public boolean isEmpty()

      Returns:

    - #### clear

          public void clear()

    - #### setUnique

          public void setUnique(boolean on)

      Parameters:
        `on` -

    - #### addListSelectionListener

          public void addListSelectionListener(javax.swing.event.ListSelectionListener l)

      Parameters:
        `l` -

    - #### addMouseListener

          public void addMouseListener(java.awt.event.MouseListener m)

      Overrides:
        `addMouseListener` in class `java.awt.Component`

    - #### iterator

          public java.util.Iterator<T> iterator()

      Specified by:
        `iterator` in interface `java.lang.Iterable<T>`

    - #### highlightChanged

          public void highlightChanged()

    - #### clearHighlight

          public void clearHighlight()

    - #### getAll

          public java.util.ArrayList<T> getAll()

      Returns:

    - #### addHelpHandler

          protected void addHelpHandler(boolean hoverListener)

      Description copied from class: `LHelpComponent`
      Adds a help handler to each GUI component that should trigger the help panel to update.
      Specified by:
        `addHelpHandler` in class `LHelpComponent`